use std::collections::HashMap;

use glium::glutin;
use glutin::event::*;

pub struct DeviceManager {
    key_map: HashMap<VirtualKeyCode, ElementState>
}

impl DeviceManager {
    pub fn handle(&mut self, event: DeviceEvent) {
	match event {
	    DeviceEvent::Key(
		KeyboardInput{ virtual_keycode: Some(keycode), state, .. }
	    ) => self.update(keycode, state),
	    _ => (),
	};
    }
    pub fn new() -> Self {
	DeviceManager {
	    key_map: HashMap::new(),
	}
    }
    pub fn is_pressed(&self, keycode: &VirtualKeyCode) -> bool {
	matches!(self.key_map.get(keycode), Some(ElementState::Pressed))
    }
    fn update(&mut self, keycode: VirtualKeyCode, state: ElementState) {
	self.key_map.insert(keycode, state);
    }
	
}
